#!/usr/bin/perl -T
#$Id: ajax.cgi,v 1.8 2015/01/27 13:50:04 sqko Exp $
use strict;
use warnings;
use RFC::Main;
use CGI qw(:standard :netscape);
use RFC::RFCCGI qw(xss);
print header(-charset=>'utf-8');
exit unless (param);
my $uid = undef;
my $user = param('name');
my $action = param('action');
exit unless $action;
if ($action eq 'logout')
{
    print  xss(&RFC::Main::passwd_client('logout_user',$user));
    exit;
}
if ($action eq 'is_logged_in')
{
    my $value =  &RFC::Main::passwd_client('is_logged_in',$user)+0;
    if ($value)
    {
        print "YES\n";
    }
    else
    {
        print "NO\n";
    }
    exit;
}

if ($action eq 'list_ttys')
{
    my $cmd = '/bin/ps -elf | /bin/grep serial | /bin/grep tty';
    my @list = `$cmd`;
    my %ttys = ();
    foreach my $line(@list)
    {
	chomp $line;
	if ($line =~ /(ttyS\d+)$/)
	{
	    $ttys{$1} = 1;
	    next;
	}
	if ($line =~ /(ttyS\d+)/)
	{
	    $ttys{$1} = 1;
	}
    }
    $cmd = '/bin/ps -elf | /bin/grep relay | /bin/grep tty';
    @list = `$cmd`;
    foreach my $line(@list)
    {
	chomp $line;
	if ($line =~ /(ttyS\d+)$/)
	{
	    $ttys{$1} = 1;
	    next;
	}
	if ($line =~ /(ttyS\d+)/)
	{
	    $ttys{$1} = 1;
	}
    }
    if (%ttys)
    {
	print "Curently avaliable tty's\n";
	print join("\n",(sort {$a cmp $b} keys %ttys)),"\n";
    }
    else
    {
	print "Error: no serial servers could be found!";
    }
    exit;
}

my $pass = param('pass');
$uid =  &RFC::Main::passwd_client('pwdstatus',$user,$pass);
exit unless ($uid);
