/* $Id: RFCcontrol.js,v 1.13 2014/03/13 11:38:21 sqko Exp $ */

function doAlertLogout(t) {
    var tt = setTimeout('dologout()',t);
}

function dologout()
{
        IsLoggedIn = 0;
        document.logout.Logout.value = 'To front page';
	parent.location = "prelogin.cgi";
        alert('You have been automatically logged out!');
}


function is_int(element)
{
        var val = element.value;
        reg = /^\d+$/;
        if (!reg.test(val))
        {
                alert("'"+val+"' is not an integer!")
                element.focus();
                element.select();
                return false;
        }
        return true;
}

function is_float(element)
{
        var val = element.value;
        reg = /^[\d\.\-\+eE]+$/;
        if (!reg.test(val))
        {
                alert("'"+val+"' is not an number!")
                element.focus();
                element.select();
                return false;
        }
        return true;
}

/* AJAX functions */


function ajax_ok(script,tagname,element){
    var user = document.login_info.name.value;
    var pass = document.login_info.pass.value;
    var time = document.login_info.time.value;
    var rig = document.login_info.rig.value;
    var js = document.login_info.jscheck.value;
    var rnd = "&rnd="+ Math.random();
    if (element.value == null || element.value.length == 0)
    {
        // No need to run query if input is empty
        element.value = '';
        return false;
    }
    var ajaxRequest;   // The variable that makes Ajax possible!
    try{
        // Opera 8.0+, Firefox, Safari
        ajaxRequest = new XMLHttpRequest();
    } catch (e){
        // Internet Explorer Browsers
        try{
             ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
             try{
                  ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
             } catch (e){
                  // Something went wrong
                  alert("Your browser broke!");
                  return false;
             }
        }
    }
    // Create a function that will receive data sent from the server
    ajaxRequest.onreadystatechange = function(){
        if(ajaxRequest.readyState == 4){
            // This is what actually is done once ajax request has finished
            if (ajaxRequest.responseText != "OK")
            {
                alert(ajaxRequest.responseText);
                element.value = '';
                element.focus();
            }
        }
    }
    var hidden = "?ajax=1&name="+user+"&pass="+pass+"&time="+time+rnd+"&rig="+rig+"&jscheck="+js;
    var query = "@"+tagname+"="+element.value;
    ajaxRequest.open("GET", script+hidden+query, true);
    ajaxRequest.send(null);
}

function raw_ajax(script,query,func){
    var ajaxRequest;  // The variable that makes Ajax possible!
        try{
            // Opera 8.0+, Firefox, Safari
                ajaxRequest = new XMLHttpRequest();
        } catch (e){
            // Internet Explorer Browsers
                try{
                    ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
                } catch (e) {
                    try{
                        ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
                    } catch (e){
                        // Something went wrong
                            alert("Your browser broke!");
                        return false;
                    }
                }
        }
    // Create a function that will receive data sent from the server
        ajaxRequest.onreadystatechange = function(){
            if(ajaxRequest.readyState == 4){
                // This is what actually is done once ajax request has finished
                    func(ajaxRequest.responseText);
            }
        }
    ajaxRequest.open("GET", script+query, true);
    ajaxRequest.send(null);
}


function run_ajax(script,query,func){
    var user = document.login_info.name.value;
    var pass = document.login_info.pass.value;
    var time = document.login_info.time.value;
    var rig = document.login_info.rig.value;
    var js = document.login_info.jscheck.value;
    var rnd = "&rnd="+ Math.random();
    var ajaxRequest;  // The variable that makes Ajax possible!
        try{
            // Opera 8.0+, Firefox, Safari
                ajaxRequest = new XMLHttpRequest();
        } catch (e){
            // Internet Explorer Browsers
                try{
                    ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
                } catch (e) {
                    try{
                        ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
                    } catch (e){
                        // Something went wrong
                            alert("Your browser broke!");
                        return false;
                    }
                }
        }
    // Create a function that will receive data sent from the server
        ajaxRequest.onreadystatechange = function(){
            if(ajaxRequest.readyState == 4){
                // This is what actually is done once ajax request has finished
                    func(ajaxRequest.responseText);
            }
        }
    var hidden = "?ajax=1&name="+user+"&pass="+pass+"&time="+time+rnd+"&rig="+rig+"&jscheck="+js
    ajaxRequest.open("GET", script+hidden+query, true);
    ajaxRequest.send(null);
}


function ajax_alert(s)
{
    if (s == "OK")
    {
        return true;
    }
    alert(s);
    return false;
}


function RFC_open(script,w,h,l,t)
{
    var user = document.login_info.name.value;
    var pass = document.login_info.pass.value;
    var time = document.login_info.time.value;
    var rig = document.login_info.rig.value;
    var js = document.login_info.jscheck.value;
    var hidden = "?name="+user+"&pass="+pass+"&time="+time+"&rig="+rig+"&jscheck="+js
    var myWindow=window.open(script+hidden,'windowRef','width='+w+',height='+h+',left='+l+',top='+t);
    myWindow.location.href = script+hidden;
    if (!myWindow.opener)
        myWindow.opener = self;
    myWindow.focus();
}



/*   Fix for broken onblur() in IE *Argh* */

var active_element;
var bIsMSIE = false;

function save_active()
{
	active_element = document.activeElement;
}



/*
In Internet Explorer 'onblur' event is implemented incorrectly (as opposed to Firefox/Mozilla browsers).
It is wrongly fired when focus is switched between HTML elements *inside* a window. As a result, clicking
on any element *inside* a popup window or trying to select something there will also close a popup.
Below is a workaround.
*/

function initiateSelfClosing()
{
	if (navigator.appName == "Microsoft Internet Explorer") {
		active_element = document.activeElement;
		document.onfocusout = closeWnd;
		bIsMSIE = true;
	}
	else 
	{ 
		window.onblur = closeWnd; 
	}
}


function closeWnd()
{
	if (window.opener != null) {
		if (bIsMSIE && (active_element != document.activeElement)) {
			active_element = document.activeElement;
		}
		else 
		{
			window.close();
		}
	}
}